Index: lemon/dfs.h
===================================================================
--- lemon/dfs.h	(revision 327)
+++ lemon/dfs.h	(revision 220)
@@ -721,59 +708,60 @@
                                   G->source((*_pred)[v]); }
 
-    ///\brief Returns a const reference to the node map that stores the
-    ///distances of the nodes.
-    ///
-    ///Returns a const reference to the node map that stores the
-    ///distances of the nodes calculated by the algorithm.
-    ///
-    ///\pre Either \ref run() or \ref init()
-    ///must be called before using this function.
+    ///Returns a reference to the NodeMap of distances.
+
+    ///Returns a reference to the NodeMap of distances.
+    ///\pre Either \ref run() or \ref init() must
+    ///be called before using this function.
     const DistMap &distMap() const { return *_dist;}
 
-    ///\brief Returns a const reference to the node map that stores the
-    ///predecessor arcs.
-    ///
-    ///Returns a const reference to the node map that stores the predecessor
-    ///arcs, which form the DFS tree.
-    ///
+    ///Returns a reference to the %DFS arc-tree map.
+
+    ///Returns a reference to the NodeMap of the arcs of the
+    ///%DFS tree.
     ///\pre Either \ref run() or \ref init()
     ///must be called before using this function.
     const PredMap &predMap() const { return *_pred;}
 
-    ///Checks if a node is reachable from the root(s).
+    ///Checks if a node is reachable from the root.
 
     ///Returns \c true if \c v is reachable from the root(s).
+    ///\warning The source nodes are inditated as unreachable.
     ///\pre Either \ref run() or \ref start()
     ///must be called before using this function.
-    bool reached(Node v) const { return (*_reached)[v]; }
+    ///
+    bool reached(Node v) { return (*_reached)[v]; }
 
     ///@}
   };
 
-  ///Default traits class of dfs() function.
-
-  ///Default traits class of dfs() function.
+  ///Default traits class of Dfs function.
+
+  ///Default traits class of Dfs function.
   ///\tparam GR Digraph type.
   template<class GR>
   struct DfsWizardDefaultTraits
   {
-    ///The type of the digraph the algorithm runs on.
+    ///The digraph type the algorithm runs on.
     typedef GR Digraph;
-
-    ///\brief The type of the map that stores the predecessor
+    ///\brief The type of the map that stores the last
     ///arcs of the %DFS paths.
     ///
-    ///The type of the map that stores the predecessor
+    ///The type of the map that stores the last
     ///arcs of the %DFS paths.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    typedef typename Digraph::template NodeMap<typename Digraph::Arc> PredMap;
+    ///
+    typedef NullMap<typename Digraph::Node,typename GR::Arc> PredMap;
     ///Instantiates a PredMap.
 
-    ///This function instantiates a PredMap.
-    ///\param g is the digraph, to which we would like to define the
-    ///PredMap.
-    static PredMap *createPredMap(const Digraph &g)
-    {
-      return new PredMap(g);
+    ///This function instantiates a \ref PredMap.
+    ///\param g is the digraph, to which we would like to define the PredMap.
+    ///\todo The digraph alone may be insufficient to initialize
+#ifdef DOXYGEN
+    static PredMap *createPredMap(const GR &g)
+#else
+    static PredMap *createPredMap(const GR &)
+#endif
+    {
+      return new PredMap();
     }
 
@@ -782,63 +770,61 @@
     ///The type of the map that indicates which nodes are processed.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    ///By default it is a NullMap.
+    ///\todo named parameter to set this type, function to read and write.
     typedef NullMap<typename Digraph::Node,bool> ProcessedMap;
     ///Instantiates a ProcessedMap.
 
-    ///This function instantiates a ProcessedMap.
+    ///This function instantiates a \ref ProcessedMap.
     ///\param g is the digraph, to which
-    ///we would like to define the ProcessedMap.
+    ///we would like to define the \ref ProcessedMap
 #ifdef DOXYGEN
-    static ProcessedMap *createProcessedMap(const Digraph &g)
+    static ProcessedMap *createProcessedMap(const GR &g)
 #else
-    static ProcessedMap *createProcessedMap(const Digraph &)
+    static ProcessedMap *createProcessedMap(const GR &)
 #endif
     {
       return new ProcessedMap();
     }
-
     ///The type of the map that indicates which nodes are reached.
 
     ///The type of the map that indicates which nodes are reached.
-    ///It must meet the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    ///\todo named parameter to set this type, function to read and write.
     typedef typename Digraph::template NodeMap<bool> ReachedMap;
     ///Instantiates a ReachedMap.
 
-    ///This function instantiates a ReachedMap.
-    ///\param g is the digraph, to which
-    ///we would like to define the ReachedMap.
-    static ReachedMap *createReachedMap(const Digraph &g)
-    {
-      return new ReachedMap(g);
-    }
-
-    ///The type of the map that stores the distances of the nodes.
-
-    ///The type of the map that stores the distances of the nodes.
+    ///This function instantiates a \ref ReachedMap.
+    ///\param G is the digraph, to which
+    ///we would like to define the \ref ReachedMap.
+    static ReachedMap *createReachedMap(const GR &G)
+    {
+      return new ReachedMap(G);
+    }
+    ///The type of the map that stores the dists of the nodes.
+
+    ///The type of the map that stores the dists of the nodes.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    typedef typename Digraph::template NodeMap<int> DistMap;
+    ///
+    typedef NullMap<typename Digraph::Node,int> DistMap;
     ///Instantiates a DistMap.
 
-    ///This function instantiates a DistMap.
+    ///This function instantiates a \ref DistMap.
     ///\param g is the digraph, to which we would like to define
-    ///the DistMap
-    static DistMap *createDistMap(const Digraph &g)
-    {
-      return new DistMap(g);
-    }
-
-    ///The type of the DFS paths.
-
-    ///The type of the DFS paths.
-    ///It must meet the \ref concepts::Path "Path" concept.
-    typedef lemon::Path<Digraph> Path;
+    ///the \ref DistMap
+#ifdef DOXYGEN
+    static DistMap *createDistMap(const GR &g)
+#else
+    static DistMap *createDistMap(const GR &)
+#endif
+    {
+      return new DistMap();
+    }
   };
 
-  /// Default traits class used by DfsWizard
+  /// Default traits used by \ref DfsWizard
 
   /// To make it easier to use Dfs algorithm
-  /// we have created a wizard class.
+  ///we have created a wizard class.
   /// This \ref DfsWizard class needs default traits,
-  /// as well as the \ref Dfs class.
+  ///as well as the \ref Dfs class.
   /// The \ref DfsWizardBase is a class to be the default traits of the
   /// \ref DfsWizard class.
@@ -849,21 +835,19 @@
     typedef DfsWizardDefaultTraits<GR> Base;
   protected:
-    //The type of the nodes in the digraph.
+    /// Type of the nodes in the digraph.
     typedef typename Base::Digraph::Node Node;
 
-    //Pointer to the digraph the algorithm runs on.
+    /// Pointer to the underlying digraph.
     void *_g;
-    //Pointer to the map of reached nodes.
+    ///Pointer to the map of reached nodes.
     void *_reached;
-    //Pointer to the map of processed nodes.
+    ///Pointer to the map of processed nodes.
     void *_processed;
-    //Pointer to the map of predecessors arcs.
+    ///Pointer to the map of predecessors arcs.
     void *_pred;
-    //Pointer to the map of distances.
+    ///Pointer to the map of distances.
     void *_dist;
-    //Pointer to the DFS path to the target node.
-    void *_path;
-    //Pointer to the distance of the target node.
-    int *_di;
+    ///Pointer to the source node.
+    Node _source;
 
     public:
@@ -871,28 +855,40 @@
 
     /// This constructor does not require parameters, therefore it initiates
-    /// all of the attributes to \c 0.
+    /// all of the attributes to default values (0, INVALID).
     DfsWizardBase() : _g(0), _reached(0), _processed(0), _pred(0),
-                      _dist(0), _path(0), _di(0) {}
+                           _dist(0), _source(INVALID) {}
 
     /// Constructor.
 
-    /// This constructor requires one parameter,
-    /// others are initiated to \c 0.
-    /// \param g The digraph the algorithm runs on.
-    DfsWizardBase(const GR &g) :
+    /// This constructor requires some parameters,
+    /// listed in the parameters list.
+    /// Others are initiated to 0.
+    /// \param g is the initial value of  \ref _g
+    /// \param s is the initial value of  \ref _source
+    DfsWizardBase(const GR &g, Node s=INVALID) :
       _g(reinterpret_cast<void*>(const_cast<GR*>(&g))),
-      _reached(0), _processed(0), _pred(0), _dist(0),  _path(0), _di(0) {}
+      _reached(0), _processed(0), _pred(0), _dist(0), _source(s) {}
 
   };
 
-  /// Auxiliary class for the function-type interface of DFS algorithm.
-
-  /// This auxiliary class is created to implement the
-  /// \ref dfs() "function-type interface" of \ref Dfs algorithm.
-  /// It does not have own \ref run() method, it uses the functions
-  /// and features of the plain \ref Dfs.
+  /// A class to make the usage of the Dfs algorithm easier
+
+  /// This class is created to make it easier to use the Dfs algorithm.
+  /// It uses the functions and features of the plain \ref Dfs,
+  /// but it is much simpler to use it.
   ///
-  /// This class should only be used through the \ref dfs() function,
-  /// which makes it easier to use the algorithm.
+  /// Simplicity means that the way to change the types defined
+  /// in the traits class is based on functions that returns the new class
+  /// and not on templatable built-in classes.
+  /// When using the plain \ref Dfs
+  /// the new class with the modified type comes from
+  /// the original class by using the ::
+  /// operator. In the case of \ref DfsWizard only
+  /// a function have to be called and it will
+  /// return the needed class.
+  ///
+  /// It does not have own \ref run method. When its \ref run method is called
+  /// it initiates a plain \ref Dfs object, and calls the \ref Dfs::run
+  /// method of it.
   template<class TR>
   class DfsWizard : public TR
@@ -900,26 +896,28 @@
     typedef TR Base;
 
-    ///The type of the digraph the algorithm runs on.
+    ///The type of the underlying digraph.
     typedef typename TR::Digraph Digraph;
-
+    //\e
     typedef typename Digraph::Node Node;
+    //\e
     typedef typename Digraph::NodeIt NodeIt;
+    //\e
     typedef typename Digraph::Arc Arc;
+    //\e
     typedef typename Digraph::OutArcIt OutArcIt;
 
-    ///\brief The type of the map that stores the predecessor
-    ///arcs of the DFS paths.
+    ///\brief The type of the map that stores
+    ///the reached nodes
+    typedef typename TR::ReachedMap ReachedMap;
+    ///\brief The type of the map that stores
+    ///the processed nodes
+    typedef typename TR::ProcessedMap ProcessedMap;
+    ///\brief The type of the map that stores the last
+    ///arcs of the %DFS paths.
     typedef typename TR::PredMap PredMap;
-    ///\brief The type of the map that stores the distances of the nodes.
+    ///The type of the map that stores the distances of the nodes.
     typedef typename TR::DistMap DistMap;
-    ///\brief The type of the map that indicates which nodes are reached.
-    typedef typename TR::ReachedMap ReachedMap;
-    ///\brief The type of the map that indicates which nodes are processed.
-    typedef typename TR::ProcessedMap ProcessedMap;
-    ///The type of the DFS paths
-    typedef typename TR::Path Path;
 
   public:
-
     /// Constructor.
     DfsWizard() : TR() {}
@@ -929,7 +927,6 @@
     /// Constructor that requires parameters.
     /// These parameters will be the default values for the traits class.
-    /// \param g The digraph the algorithm runs on.
-    DfsWizard(const Digraph &g) :
-      TR(g) {}
+    DfsWizard(const Digraph &g, Node s=INVALID) :
+      TR(g,s) {}
 
     ///Copy constructor
@@ -938,157 +935,122 @@
     ~DfsWizard() {}
 
-    ///Runs DFS algorithm from the given source node.
-
-    ///This method runs DFS algorithm from node \c s
-    ///in order to compute the DFS path to each node.
+    ///Runs Dfs algorithm from a given node.
+
+    ///Runs Dfs algorithm from a given node.
+    ///The node can be given by the \ref source function.
+    void run()
+    {
+      if(Base::_source==INVALID) throw UninitializedParameter();
+      Dfs<Digraph,TR> alg(*reinterpret_cast<const Digraph*>(Base::_g));
+      if(Base::_reached)
+        alg.reachedMap(*reinterpret_cast<ReachedMap*>(Base::_reached));
+      if(Base::_processed)
+        alg.processedMap(*reinterpret_cast<ProcessedMap*>(Base::_processed));
+      if(Base::_pred)
+        alg.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
+      if(Base::_dist)
+        alg.distMap(*reinterpret_cast<DistMap*>(Base::_dist));
+      alg.run(Base::_source);
+    }
+
+    ///Runs Dfs algorithm from the given node.
+
+    ///Runs Dfs algorithm from the given node.
+    ///\param s is the given source.
     void run(Node s)
     {
-      Dfs<Digraph,TR> alg(*reinterpret_cast<const Digraph*>(Base::_g));
-      if (Base::_pred)
-        alg.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
-      if (Base::_dist)
-        alg.distMap(*reinterpret_cast<DistMap*>(Base::_dist));
-      if (Base::_reached)
-        alg.reachedMap(*reinterpret_cast<ReachedMap*>(Base::_reached));
-      if (Base::_processed)
-        alg.processedMap(*reinterpret_cast<ProcessedMap*>(Base::_processed));
-      if (s!=INVALID)
-        alg.run(s);
-      else
-        alg.run();
-    }
-
-    ///Finds the DFS path between \c s and \c t.
-
-    ///This method runs DFS algorithm from node \c s
-    ///in order to compute the DFS path to node \c t
-    ///(it stops searching when \c t is processed).
-    ///
-    ///\return \c true if \c t is reachable form \c s.
-    bool run(Node s, Node t)
-    {
-      Dfs<Digraph,TR> alg(*reinterpret_cast<const Digraph*>(Base::_g));
-      if (Base::_pred)
-        alg.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
-      if (Base::_dist)
-        alg.distMap(*reinterpret_cast<DistMap*>(Base::_dist));
-      if (Base::_reached)
-        alg.reachedMap(*reinterpret_cast<ReachedMap*>(Base::_reached));
-      if (Base::_processed)
-        alg.processedMap(*reinterpret_cast<ProcessedMap*>(Base::_processed));
-      alg.run(s,t);
-      if (Base::_path)
-        *reinterpret_cast<Path*>(Base::_path) = alg.path(t);
-      if (Base::_di)
-        *Base::_di = alg.dist(t);
-      return alg.reached(t);
-      }
-
-    ///Runs DFS algorithm to visit all nodes in the digraph.
-
-    ///This method runs DFS algorithm in order to compute
-    ///the DFS path to each node.
-    void run()
-    {
-      run(INVALID);
+      Base::_source=s;
+      run();
     }
 
     template<class T>
-    struct SetPredMapBase : public Base {
+    struct DefPredMapBase : public Base {
       typedef T PredMap;
       static PredMap *createPredMap(const Digraph &) { return 0; };
-      SetPredMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting PredMap object.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for setting PredMap object.
+      DefPredMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting PredMap type
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting PredMap type
+    ///
     template<class T>
-    DfsWizard<SetPredMapBase<T> > predMap(const T &t)
+    DfsWizard<DefPredMapBase<T> > predMap(const T &t)
     {
       Base::_pred=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return DfsWizard<SetPredMapBase<T> >(*this);
-    }
+      return DfsWizard<DefPredMapBase<T> >(*this);
+    }
+
 
     template<class T>
-    struct SetReachedMapBase : public Base {
+    struct DefReachedMapBase : public Base {
       typedef T ReachedMap;
       static ReachedMap *createReachedMap(const Digraph &) { return 0; };
-      SetReachedMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting ReachedMap object.
-    ///
-    /// \ref named-func-param "Named parameter"
-    ///for setting ReachedMap object.
+      DefReachedMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting ReachedMap
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting ReachedMap
+    ///
     template<class T>
-    DfsWizard<SetReachedMapBase<T> > reachedMap(const T &t)
+    DfsWizard<DefReachedMapBase<T> > reachedMap(const T &t)
     {
       Base::_reached=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return DfsWizard<SetReachedMapBase<T> >(*this);
-    }
+      return DfsWizard<DefReachedMapBase<T> >(*this);
+    }
+
 
     template<class T>
-    struct SetDistMapBase : public Base {
+    struct DefProcessedMapBase : public Base {
+      typedef T ProcessedMap;
+      static ProcessedMap *createProcessedMap(const Digraph &) { return 0; };
+      DefProcessedMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting ProcessedMap
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting ProcessedMap
+    ///
+    template<class T>
+    DfsWizard<DefProcessedMapBase<T> > processedMap(const T &t)
+    {
+      Base::_processed=reinterpret_cast<void*>(const_cast<T*>(&t));
+      return DfsWizard<DefProcessedMapBase<T> >(*this);
+    }
+
+    template<class T>
+    struct DefDistMapBase : public Base {
       typedef T DistMap;
       static DistMap *createDistMap(const Digraph &) { return 0; };
-      SetDistMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting DistMap object.
-    ///
-    /// \ref named-func-param "Named parameter"
-    ///for setting DistMap object.
+      DefDistMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting DistMap type
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting DistMap type
+    ///
     template<class T>
-    DfsWizard<SetDistMapBase<T> > distMap(const T &t)
+    DfsWizard<DefDistMapBase<T> > distMap(const T &t)
     {
       Base::_dist=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return DfsWizard<SetDistMapBase<T> >(*this);
-    }
-
-    template<class T>
-    struct SetProcessedMapBase : public Base {
-      typedef T ProcessedMap;
-      static ProcessedMap *createProcessedMap(const Digraph &) { return 0; };
-      SetProcessedMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting ProcessedMap object.
-    ///
-    /// \ref named-func-param "Named parameter"
-    ///for setting ProcessedMap object.
-    template<class T>
-    DfsWizard<SetProcessedMapBase<T> > processedMap(const T &t)
-    {
-      Base::_processed=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return DfsWizard<SetProcessedMapBase<T> >(*this);
-    }
-
-    template<class T>
-    struct SetPathBase : public Base {
-      typedef T Path;
-      SetPathBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for getting the DFS path to the target node.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for getting the DFS path to the target node.
-    template<class T>
-    DfsWizard<SetPathBase<T> > path(const T &t)
-    {
-      Base::_path=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return DfsWizard<SetPathBase<T> >(*this);
-    }
-
-    ///\brief \ref named-func-param "Named parameter"
-    ///for getting the distance of the target node.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for getting the distance of the target node.
-    DfsWizard dist(const int &d)
-    {
-      Base::_di=const_cast<int*>(&d);
+      return DfsWizard<DefDistMapBase<T> >(*this);
+    }
+
+    /// Sets the source node, from which the Dfs algorithm runs.
+
+    /// Sets the source node, from which the Dfs algorithm runs.
+    /// \param s is the source node.
+    DfsWizard<TR> &source(Node s)
+    {
+      Base::_source=s;
       return *this;
     }
@@ -1096,20 +1058,17 @@
   };
 
-  ///Function-type interface for DFS algorithm.
+  ///Function type interface for Dfs algorithm.
 
   ///\ingroup search
-  ///Function-type interface for DFS algorithm.
+  ///Function type interface for Dfs algorithm.
   ///
-  ///This function also has several \ref named-func-param "named parameters",
+  ///This function also has several
+  ///\ref named-templ-func-param "named parameters",
   ///they are declared as the members of class \ref DfsWizard.
-  ///The following examples show how to use these parameters.
+  ///The following
+  ///example shows how to use these parameters.
   ///\code
-  ///  // Compute the DFS tree
-  ///  dfs(g).predMap(preds).distMap(dists).run(s);
-  ///
-  ///  // Compute the DFS path from s to t
-  ///  bool reached = dfs(g).path(p).dist(d).run(s,t);
+  ///  dfs(g,source).predMap(preds).run();
   ///\endcode
-
   ///\warning Don't forget to put the \ref DfsWizard::run() "run()"
   ///to the end of the parameter list.
@@ -1118,14 +1077,14 @@
   template<class GR>
   DfsWizard<DfsWizardBase<GR> >
-  dfs(const GR &digraph)
+  dfs(const GR &g,typename GR::Node s=INVALID)
   {
-    return DfsWizard<DfsWizardBase<GR> >(digraph);
+    return DfsWizard<DfsWizardBase<GR> >(g,s);
   }
 
 #ifdef DOXYGEN
-  /// \brief Visitor class for DFS.
+  /// \brief Visitor class for dfs.
   ///
-  /// This class defines the interface of the DfsVisit events, and
-  /// it could be the base of a real visitor class.
+  /// It gives a simple interface for a functional interface for dfs
+  /// traversal. The traversal on a linear data structure.
   template <typename _Digraph>
   struct DfsVisitor {
@@ -1133,35 +1092,36 @@
     typedef typename Digraph::Arc Arc;
     typedef typename Digraph::Node Node;
-    /// \brief Called for the source node of the DFS.
-    ///
-    /// This function is called for the source node of the DFS.
-    void start(const Node& node) {}
-    /// \brief Called when the source node is leaved.
-    ///
-    /// This function is called when the source node is leaved.
-    void stop(const Node& node) {}
-    /// \brief Called when a node is reached first time.
-    ///
-    /// This function is called when a node is reached first time.
+    /// \brief Called when the arc reach a node.
+    ///
+    /// It is called when the dfs find an arc which target is not
+    /// reached yet.
+    void discover(const Arc& arc) {}
+    /// \brief Called when the node reached first time.
+    ///
+    /// It is Called when the node reached first time.
     void reach(const Node& node) {}
-    /// \brief Called when an arc reaches a new node.
-    ///
-    /// This function is called when the DFS finds an arc whose target node
-    /// is not reached yet.
-    void discover(const Arc& arc) {}
-    /// \brief Called when an arc is examined but its target node is
+    /// \brief Called when we step back on an arc.
+    ///
+    /// It is called when the dfs should step back on the arc.
+    void backtrack(const Arc& arc) {}
+    /// \brief Called when we step back from the node.
+    ///
+    /// It is called when we step back from the node.
+    void leave(const Node& node) {}
+    /// \brief Called when the arc examined but target of the arc
     /// already discovered.
     ///
-    /// This function is called when an arc is examined but its target node is
+    /// It called when the arc examined but the target of the arc
     /// already discovered.
     void examine(const Arc& arc) {}
-    /// \brief Called when the DFS steps back from a node.
-    ///
-    /// This function is called when the DFS steps back from a node.
-    void leave(const Node& node) {}
-    /// \brief Called when the DFS steps back on an arc.
-    ///
-    /// This function is called when the DFS steps back on an arc.
-    void backtrack(const Arc& arc) {}
+    /// \brief Called for the source node of the dfs.
+    ///
+    /// It is called for the source node of the dfs.
+    void start(const Node& node) {}
+    /// \brief Called when we leave the source node of the dfs.
+    ///
+    /// It is called when we leave the source node of the dfs.
+    void stop(const Node& node) {}
+
   };
 #else
@@ -1171,11 +1131,11 @@
     typedef typename Digraph::Arc Arc;
     typedef typename Digraph::Node Node;
+    void discover(const Arc&) {}
+    void reach(const Node&) {}
+    void backtrack(const Arc&) {}
+    void leave(const Node&) {}
+    void examine(const Arc&) {}
     void start(const Node&) {}
     void stop(const Node&) {}
-    void reach(const Node&) {}
-    void discover(const Arc&) {}
-    void examine(const Arc&) {}
-    void leave(const Node&) {}
-    void backtrack(const Arc&) {}
 
     template <typename _Visitor>
@@ -1184,11 +1144,11 @@
         Arc arc;
         Node node;
+        visitor.discover(arc);
+        visitor.reach(node);
+        visitor.backtrack(arc);
+        visitor.leave(node);
+        visitor.examine(arc);
         visitor.start(node);
         visitor.stop(arc);
-        visitor.reach(node);
-        visitor.discover(arc);
-        visitor.examine(arc);
-        visitor.leave(node);
-        visitor.backtrack(arc);
       }
       _Visitor& visitor;
@@ -1200,9 +1160,9 @@
   ///
   /// Default traits class of DfsVisit class.
-  /// \tparam _Digraph The type of the digraph the algorithm runs on.
+  /// \tparam _Digraph Digraph type.
   template<class _Digraph>
   struct DfsVisitDefaultTraits {
 
-    /// \brief The type of the digraph the algorithm runs on.
+    /// \brief The digraph type the algorithm runs on.
     typedef _Digraph Digraph;
 
@@ -1210,12 +1170,13 @@
     ///
     /// The type of the map that indicates which nodes are reached.
-    /// It must meet the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    /// It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    /// \todo named parameter to set this type, function to read and write.
     typedef typename Digraph::template NodeMap<bool> ReachedMap;
 
     /// \brief Instantiates a ReachedMap.
     ///
-    /// This function instantiates a ReachedMap.
+    /// This function instantiates a \ref ReachedMap.
     /// \param digraph is the digraph, to which
-    /// we would like to define the ReachedMap.
+    /// we would like to define the \ref ReachedMap.
     static ReachedMap *createReachedMap(const Digraph &digraph) {
       return new ReachedMap(digraph);
@@ -1224,8 +1185,7 @@
   };
 
+  /// %DFS Visit algorithm class.
+
   /// \ingroup search
-  ///
-  /// \brief %DFS algorithm class with visitor interface.
-  ///
   /// This class provides an efficient implementation of the %DFS algorithm
   /// with visitor interface.
@@ -1233,24 +1193,21 @@
   /// The %DfsVisit class provides an alternative interface to the Dfs
   /// class. It works with callback mechanism, the DfsVisit object calls
-  /// the member functions of the \c Visitor class on every DFS event.
+  /// on every dfs event the \c Visitor class member functions.
   ///
-  /// This interface of the DFS algorithm should be used in special cases
-  /// when extra actions have to be performed in connection with certain
-  /// events of the DFS algorithm. Otherwise consider to use Dfs or dfs()
-  /// instead.
-  ///
-  /// \tparam _Digraph The type of the digraph the algorithm runs on.
+  /// \tparam _Digraph The digraph type the algorithm runs on.
   /// The default value is
-  /// \ref ListDigraph. The value of _Digraph is not used directly by
-  /// \ref DfsVisit, it is only passed to \ref DfsVisitDefaultTraits.
-  /// \tparam _Visitor The Visitor type that is used by the algorithm.
-  /// \ref DfsVisitor "DfsVisitor<_Digraph>" is an empty visitor, which
-  /// does not observe the DFS events. If you want to observe the DFS
-  /// events, you should implement your own visitor class.
+  /// \ref ListDigraph. The value of _Digraph is not used directly by Dfs, it
+  /// is only passed to \ref DfsDefaultTraits.
+  /// \tparam _Visitor The Visitor object for the algorithm. The
+  /// \ref DfsVisitor "DfsVisitor<_Digraph>" is an empty Visitor which
+  /// does not observe the Dfs events. If you want to observe the dfs
+  /// events you should implement your own Visitor class.
   /// \tparam _Traits Traits class to set various data types used by the
   /// algorithm. The default traits class is
   /// \ref DfsVisitDefaultTraits "DfsVisitDefaultTraits<_Digraph>".
   /// See \ref DfsVisitDefaultTraits for the documentation of
-  /// a DFS visit traits class.
+  /// a Dfs visit traits class.
+  ///
+  /// \author Jacint Szabo, Alpar Juttner and Balazs Dezso
 #ifdef DOXYGEN
   template <typename _Digraph, typename _Visitor, typename _Traits>
@@ -1258,19 +1215,28 @@
   template <typename _Digraph = ListDigraph,
             typename _Visitor = DfsVisitor<_Digraph>,
-            typename _Traits = DfsVisitDefaultTraits<_Digraph> >
+            typename _Traits = DfsDefaultTraits<_Digraph> >
 #endif
   class DfsVisit {
   public:
 
-    ///The traits class.
+    /// \brief \ref Exception for uninitialized parameters.
+    ///
+    /// This error represents problems in the initialization
+    /// of the parameters of the algorithms.
+    class UninitializedParameter : public lemon::UninitializedParameter {
+    public:
+      virtual const char* what() const throw()
+      {
+        return "lemon::DfsVisit::UninitializedParameter";
+      }
+    };
+
     typedef _Traits Traits;
 
-    ///The type of the digraph the algorithm runs on.
     typedef typename Traits::Digraph Digraph;
 
-    ///The visitor type used by the algorithm.
     typedef _Visitor Visitor;
 
-    ///The type of the map that indicates which nodes are reached.
+    ///The type of the map indicating which nodes are reached.
     typedef typename Traits::ReachedMap ReachedMap;
 
@@ -1282,11 +1248,11 @@
     typedef typename Digraph::OutArcIt OutArcIt;
 
-    //Pointer to the underlying digraph.
+    /// Pointer to the underlying digraph.
     const Digraph *_digraph;
-    //Pointer to the visitor object.
+    /// Pointer to the visitor object.
     Visitor *_visitor;
-    //Pointer to the map of reached status of the nodes.
+    ///Pointer to the map of reached status of the nodes.
     ReachedMap *_reached;
-    //Indicates if _reached is locally allocated (true) or not.
+    ///Indicates if \ref _reached is locally allocated (\c true) or not.
     bool local_reached;
 
@@ -1294,5 +1260,7 @@
     int _stack_head;
 
-    //Creates the maps if necessary.
+    /// \brief Creates the maps if necessary.
+    ///
+    /// Creates the maps if necessary.
     void create_maps() {
       if(!_reached) {
